Opening an msg attachment in EUC or Shift_JIS leads to a crash when JPN detector is on

VERIFIED FIXED in M9

Status

MailNews Core
Internationalization
P3
critical
VERIFIED FIXED
19 years ago
10 years ago

People

(Reporter: Katsuhiko Momoi, Assigned: Frank Tang)

Tracking

Trunk
x86
Windows NT

Firefox Tracking Flags

(Not tracked)

Details

(Reporter)

Description

19 years ago
** Observed with 7/27/99 Win32 M9 (non-necko) build **

The following has been split from Bug 8899:

The new chardte module seems to be working better with the Browser
though it fails on un-labeled ISO-2022-JP page.

On the Mail side, this causes a crash with all the attachment
test cases (ISO-2022-JP, EUC-JP, and Shift_JIS).

Basically, as Messenger begins to load an attachment,
it crashes.

Here's part of what I sent to Talkback.


Trigger Type:  Program Crash
Trigger Reason:  Access violation
Call Stack:    (Signature = nsXPCOMStringDetector::Report f121549c)
nsXPCOMStringDetector::Report[d:\builds\seamonkey\mozilla\intl\chardet\src\nsPSM
Detectors.cpp, line 421]
MimeCharsetConverterClass::Convert[d:\builds\seamonkey\mozilla\mailnews\mime\src
\comi18n.cpp, line 1410]
MIME_ConvertCharset [d:\builds\seamonkey\mozilla\mailnews\mime\src\comi18n.cpp,
line 1549]
mime_convert_charset[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimemoz2.cpp,
line 160]
MimeInlineText_rotate_convert_and_parse_line[d:\builds\seamonkey\mozilla\mailnew
s\mime\src\mimetext.cpp, line 292]
convert_and_send_buffer[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimebuf.cp
p, line 113]
mime_LineBuffer [d:\builds\seamonkey\mozilla\mailnews\mime\src\mimebuf.cpp, line
235]
MimeInlineText_parse_decoded_buffer[d:\builds\seamonkey\mozilla\mailnews\mime\sr
c\mimetext.cpp, line 237]
mime_decode_base64_buffer[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimeenc.
cpp, line 300]
MimeDecoderWrite [d:\builds\seamonkey\mozilla\mailnews\mime\src\mimeenc.cpp,
line 603]
MimeLeaf_parse_buffer[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimeleaf.cpp
, line 149]
MimeMultipart_parse_child_line[d:\builds\seamonkey\mozilla\mailnews\mime\src\mim
emult.cpp, line 538]
MimeMultipart_parse_line[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimemult.
cpp, line 207]
convert_and_send_buffer[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimebuf.cp
p, line 113]
mime_LineBuffer [d:\builds\seamonkey\mozilla\mailnews\mime\src\mimebuf.cpp, line
235]
MimeObject_parse_buffer[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimeobj.cp
p, line 220]
MimeMessage_parse_line[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimemsg.cpp
, line 172]
convert_and_send_buffer[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimebuf.cp
p, line 113]
mime_LineBuffer[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimebuf.cpp, line
235]
MimeObject_parse_buffer[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimeobj.cp
p, line 220]
MimeMessage_parse_line[d:\builds\seamonkey\mozilla\mailnews\mime\src\mimemsg.cpp
, line 110]
MimePluginInstance::Write[d:\builds\seamonkey\mozilla\mailnews\mime\src\plugin_i
nst.cpp, line 371]
plugin_stream_write[d:\builds\seamonkey\mozilla\network\cnvts\cvplugin.cpp, line
69]
net_read_file_chunk[d:\builds\seamonkey\mozilla\network\protocol\file\mkfile.c,
line 964]
net_ProcessFile[d:\builds\seamonkey\mozilla\network\protocol\file\mkfile.c, line
1328]
NET_ProcessNet[d:\builds\seamonkey\mozilla\network\main\mkgeturl.c, line 3363]
ntdll.dll + 0x74fd (0x77f674fd) 0x0010c200


------- Additional Comments From momoi@netscape.com  07/23/99 13:29 -------
If you want to see the full reports, you can view them here
but clicking on the Bug number on this page.

http://cyclone/reports/reporttemplate.cfm?style=1&reportID=1099

------- Additional Comments From nhotta@netscape.com  07/23/99 13:36 -------
In my local build, I don't see the crash.
Instead libmime got result code 0x02be1fb0 after DoIt() call.
Libmime uses the main body's charset for this case (ISO-2022-JP)
andthe attachment is displayed incorrectly or as an link.


------- Additional Comments From momoi@netscape.com  07/23/99 13:45 -------
The crash does not occur if I don't explicitly have the following
line in the prefs50,js.

user_pref("intl.charset.detector", "japsm");

But then I only get the ISO-2022-JP attachment showing correctly.
I thought we defaulted to the Japanese detection module if
no prefs50.js is defined for detector. Or has that been
changed?

------- Additional Comments From nhotta@netscape.com  07/23/99 13:56 -------
>I thought we defaulted to the Japanese detection module if
>no prefs50.js is defined for detector. Or has that been
>changed?
That's a bug in my code. It didn't fall back to 'japsm' from the beginning.
Please file a separate bug for that. I can implement fall back to 'japsm' or do
no charset detection (maybe this is better).
(Reporter)

Updated

19 years ago
Blocks: 8899
(Reporter)

Updated

19 years ago
Target Milestone: M9
(Reporter)

Comment 1

19 years ago
The other bug is set for M9 and so this one too should
be set to M9.
(Assignee)

Updated

19 years ago
Status: NEW → ASSIGNED
(Assignee)

Comment 2

19 years ago
Typo in MY_IMPL_ISUPPORTS caused bad QueryInterfae. Convert should never call
Report, but call DoIt. This is fixed now.
(Assignee)

Updated

19 years ago
Status: ASSIGNED → RESOLVED
Last Resolved: 19 years ago
Resolution: --- → FIXED
(Reporter)

Updated

19 years ago
Status: RESOLVED → VERIFIED
(Reporter)

Comment 3

19 years ago
** Checked with 7/30/99 Win32 M9 build **

The 2 attachments which caused the crash no longer crash
with this new build.
I'm going to mark this fixe verified.
Product: MailNews → Core
Product: Core → MailNews Core
You need to log in before you can comment on or make changes to this bug.